PROGRAM_NAME='tvONE_CORIOmaster_Demo'
/*
  Dealer Name: tvONE  
  System Name: Master
*/ 

#include 'tvONE_CORIOmaster_TestCmds.axi'


define_device

  dvTvONE_CORIOmaster = 0:4:0
  vdvTvONE_CORIOmaster  = 33001:1:1
  dvTP  = 10001:1:1
  

define_constant

  TP_VERSION = 118
  TP_STATUS = 119

define_variable
  
  char 
  TvONE_CORIOmaster_IP[15] = '172.16.105.3',  
  TvONE_CORIOmaster_USERNAME[100] = 'admin', 
  TvONE_CORIOmaster_PASSWORD[100] = 'adminpw';  

  integer 
  TvONE_CORIOmaster_PORT = 10001; 


define_start



define_module 'tvONE_CORIOmaster' TVONE_CORIOMASTER( 
  vdvTvONE_CORIOmaster, 
  dvTvONE_CORIOmaster, 
  TvONE_CORIOmaster_IP, 
  TvONE_CORIOmaster_PORT, 
  TvONE_CORIOmaster_USERNAME, 
  TvONE_CORIOmaster_PASSWORD)

define_event

data_event [dvTP]
{
  online:
  {
    send_command vdvTvONE_CORIOmaster, "'GET-VERSION_?;'";
  }
}

button_event [dvTP, WindowsButtons]
{
  push:
  {
	integer last
	
	last = get_last( WindowsButtons )
	send_command vdvTvONE_CORIOmaster, "'SET-WINDOW_', WindowsCmds[last]";
  }
}


button_event [dvTP, PresetButtons]
{
  push:
  {
	integer last
	
	last = get_last( PresetButtons )
	send_command vdvTvONE_CORIOmaster, "'LOAD-PRESET_', itoa( last ), ';'";
  }
}

data_event[vdvtvONE_CORIOmaster]
{
  string:
  {
	char cmdHeader[30], value[100], cmd[100], presetNum[3], statusType[3];
	integer iPresetNum;
	
	while (find_string( data.text, ';',  1 ) > 0)
	{
	  cmd = remove_string( data.text, ';', 1 );
	  cmdHeader = remove_string( cmd, ' ', 1 );
	  value = left_string( cmd, length_string( cmd ) - 1);
	  switch (cmdHeader)
	  {
		case 'VERSION ':
		{
		  send_command dvTP, "'^TXT-',itoa( TP_VERSION ),',0,', value";
		}
		case 'STATUS ':
		{
		  statusType = remove_string( value, '=', 1 );
		  statusType = left_string( statusType, length_string( statusType ) - 1);
		  if (statusType == '1')
		    Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF GREEN'";  
		    else if (statusType == '2')
		  Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF ORANGE'";  
		    else if (statusType == '3')
		  Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF RED'";  
		  
		  send_command dvTP, "'^TXT-',itoa( TP_STATUS ),',0,',value";
		}
		case 'PRESETNAME ':
		{
		  presetNum = remove_string( value, '=', 1 );
		  presetNum = left_string( presetNum, length_string( presetNum ) - 1);
		  iPresetNum = atoi( presetNum )
		  presetNum = itoa( PresetButtons[iPresetNum] );
		  send_command dvTP, "'^TXT-', presetNum ,',0,', value";
		}
		default :
		{
		  //bad command 
		}
	  }
	}
  }
}

define_program
